/*******************************************************************************
 * Copyright (c) 2015-2016 IncQuery Labs Ltd. and Ericsson AB
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     Akos Horvath, Abel Hegedus, Zoltan Ujhelyi, Peter Lunk - initial API and implementation
 *******************************************************************************/
package com.incquerylabs.uml.ralf.scoping;

import java.util.Spliterators;
import java.util.stream.Collectors;

import org.eclipse.xtext.naming.IQualifiedNameConverter.DefaultImpl;
import org.eclipse.xtext.naming.QualifiedName;

import com.google.common.base.Splitter;

public class ReducedAlfLanguageQualifiedNameConverter extends DefaultImpl {

	@Override
	public String getDelimiter() {
		return "::";
	}

	@Override
	public QualifiedName toQualifiedName(String qualifiedNameAsString) {
		String fqn = Splitter.on(getDelimiter()).splitToList(qualifiedNameAsString).stream()
				.map((String segment) -> (segment != null && segment.startsWith("'") && segment.endsWith("'"))
						? segment.substring(1, segment.length() - 1) : segment)
				.collect(Collectors.joining("::"));

		return super.toQualifiedName(fqn);
	}

}
