/**
 * Copyright (c) 2015-2016 IncQuery Labs Ltd. and Ericsson AB
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *     Akos Horvath, Abel Hegedus, Zoltan Ujhelyi, Tamas Borbas - initial API and implementation
 */
package com.incquerylabs.emdw.valuedescriptor;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EPackage;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each operation of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see com.incquerylabs.emdw.valuedescriptor.ValuedescriptorFactory
 * @model kind="package"
 * @generated
 */
public interface ValuedescriptorPackage extends EPackage {
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String copyright = "Copyright (c) 2015-2016 IncQuery Labs Ltd. and Ericsson AB\r\nAll rights reserved. This program and the accompanying materials\r\nare made available under the terms of the Eclipse Public License v1.0\r\nwhich accompanies this distribution, and is available at\r\nhttp://www.eclipse.org/legal/epl-v10.html\r\n\r\nContributors:\r\n    Akos Horvath, Abel Hegedus, Zoltan Ujhelyi, Tamas Borbas - initial API and implementation";

	/**
	 * The package name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNAME = "valuedescriptor";

	/**
	 * The package namespace URI.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_URI = "http://www.incquerylabs.com/emdw/valuedescriptor";

	/**
	 * The package namespace name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_PREFIX = "valuedescriptor";

	/**
	 * The singleton instance of the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	ValuedescriptorPackage eINSTANCE = com.incquerylabs.emdw.valuedescriptor.impl.ValuedescriptorPackageImpl.init();

	/**
	 * The meta object id for the '{@link com.incquerylabs.emdw.valuedescriptor.impl.ValueDescriptorImpl <em>Value Descriptor</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.incquerylabs.emdw.valuedescriptor.impl.ValueDescriptorImpl
	 * @see com.incquerylabs.emdw.valuedescriptor.impl.ValuedescriptorPackageImpl#getValueDescriptor()
	 * @generated
	 */
	int VALUE_DESCRIPTOR = 0;

	/**
	 * The feature id for the '<em><b>Base Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_DESCRIPTOR__BASE_TYPE = 0;

	/**
	 * The feature id for the '<em><b>Template Types</b></em>' attribute list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_DESCRIPTOR__TEMPLATE_TYPES = 1;

	/**
	 * The feature id for the '<em><b>Full Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_DESCRIPTOR__FULL_TYPE = 2;

	/**
	 * The feature id for the '<em><b>String Representation</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_DESCRIPTOR__STRING_REPRESENTATION = 3;

	/**
	 * The feature id for the '<em><b>Value Representation</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_DESCRIPTOR__VALUE_REPRESENTATION = 4;

	/**
	 * The feature id for the '<em><b>Pointer Representation</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_DESCRIPTOR__POINTER_REPRESENTATION = 5;

	/**
	 * The number of structural features of the '<em>Value Descriptor</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_DESCRIPTOR_FEATURE_COUNT = 6;

	/**
	 * The number of operations of the '<em>Value Descriptor</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_DESCRIPTOR_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link com.incquerylabs.emdw.valuedescriptor.impl.LiteralDescriptorImpl <em>Literal Descriptor</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.incquerylabs.emdw.valuedescriptor.impl.LiteralDescriptorImpl
	 * @see com.incquerylabs.emdw.valuedescriptor.impl.ValuedescriptorPackageImpl#getLiteralDescriptor()
	 * @generated
	 */
	int LITERAL_DESCRIPTOR = 1;

	/**
	 * The feature id for the '<em><b>Base Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LITERAL_DESCRIPTOR__BASE_TYPE = VALUE_DESCRIPTOR__BASE_TYPE;

	/**
	 * The feature id for the '<em><b>Template Types</b></em>' attribute list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LITERAL_DESCRIPTOR__TEMPLATE_TYPES = VALUE_DESCRIPTOR__TEMPLATE_TYPES;

	/**
	 * The feature id for the '<em><b>Full Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LITERAL_DESCRIPTOR__FULL_TYPE = VALUE_DESCRIPTOR__FULL_TYPE;

	/**
	 * The feature id for the '<em><b>String Representation</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LITERAL_DESCRIPTOR__STRING_REPRESENTATION = VALUE_DESCRIPTOR__STRING_REPRESENTATION;

	/**
	 * The feature id for the '<em><b>Value Representation</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LITERAL_DESCRIPTOR__VALUE_REPRESENTATION = VALUE_DESCRIPTOR__VALUE_REPRESENTATION;

	/**
	 * The feature id for the '<em><b>Pointer Representation</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LITERAL_DESCRIPTOR__POINTER_REPRESENTATION = VALUE_DESCRIPTOR__POINTER_REPRESENTATION;

	/**
	 * The number of structural features of the '<em>Literal Descriptor</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LITERAL_DESCRIPTOR_FEATURE_COUNT = VALUE_DESCRIPTOR_FEATURE_COUNT + 0;

	/**
	 * The number of operations of the '<em>Literal Descriptor</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LITERAL_DESCRIPTOR_OPERATION_COUNT = VALUE_DESCRIPTOR_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.incquerylabs.emdw.valuedescriptor.impl.VariableDescriptorImpl <em>Variable Descriptor</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.incquerylabs.emdw.valuedescriptor.impl.VariableDescriptorImpl
	 * @see com.incquerylabs.emdw.valuedescriptor.impl.ValuedescriptorPackageImpl#getVariableDescriptor()
	 * @generated
	 */
	int VARIABLE_DESCRIPTOR = 2;

	/**
	 * The feature id for the '<em><b>Base Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VARIABLE_DESCRIPTOR__BASE_TYPE = VALUE_DESCRIPTOR__BASE_TYPE;

	/**
	 * The feature id for the '<em><b>Template Types</b></em>' attribute list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VARIABLE_DESCRIPTOR__TEMPLATE_TYPES = VALUE_DESCRIPTOR__TEMPLATE_TYPES;

	/**
	 * The feature id for the '<em><b>Full Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VARIABLE_DESCRIPTOR__FULL_TYPE = VALUE_DESCRIPTOR__FULL_TYPE;

	/**
	 * The feature id for the '<em><b>String Representation</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VARIABLE_DESCRIPTOR__STRING_REPRESENTATION = VALUE_DESCRIPTOR__STRING_REPRESENTATION;

	/**
	 * The feature id for the '<em><b>Value Representation</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VARIABLE_DESCRIPTOR__VALUE_REPRESENTATION = VALUE_DESCRIPTOR__VALUE_REPRESENTATION;

	/**
	 * The feature id for the '<em><b>Pointer Representation</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VARIABLE_DESCRIPTOR__POINTER_REPRESENTATION = VALUE_DESCRIPTOR__POINTER_REPRESENTATION;

	/**
	 * The number of structural features of the '<em>Variable Descriptor</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VARIABLE_DESCRIPTOR_FEATURE_COUNT = VALUE_DESCRIPTOR_FEATURE_COUNT + 0;

	/**
	 * The number of operations of the '<em>Variable Descriptor</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VARIABLE_DESCRIPTOR_OPERATION_COUNT = VALUE_DESCRIPTOR_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.incquerylabs.emdw.valuedescriptor.impl.OperationCallDescriptorImpl <em>Operation Call Descriptor</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.incquerylabs.emdw.valuedescriptor.impl.OperationCallDescriptorImpl
	 * @see com.incquerylabs.emdw.valuedescriptor.impl.ValuedescriptorPackageImpl#getOperationCallDescriptor()
	 * @generated
	 */
	int OPERATION_CALL_DESCRIPTOR = 3;

	/**
	 * The feature id for the '<em><b>Base Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OPERATION_CALL_DESCRIPTOR__BASE_TYPE = VALUE_DESCRIPTOR__BASE_TYPE;

	/**
	 * The feature id for the '<em><b>Template Types</b></em>' attribute list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OPERATION_CALL_DESCRIPTOR__TEMPLATE_TYPES = VALUE_DESCRIPTOR__TEMPLATE_TYPES;

	/**
	 * The feature id for the '<em><b>Full Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OPERATION_CALL_DESCRIPTOR__FULL_TYPE = VALUE_DESCRIPTOR__FULL_TYPE;

	/**
	 * The feature id for the '<em><b>String Representation</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OPERATION_CALL_DESCRIPTOR__STRING_REPRESENTATION = VALUE_DESCRIPTOR__STRING_REPRESENTATION;

	/**
	 * The feature id for the '<em><b>Value Representation</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OPERATION_CALL_DESCRIPTOR__VALUE_REPRESENTATION = VALUE_DESCRIPTOR__VALUE_REPRESENTATION;

	/**
	 * The feature id for the '<em><b>Pointer Representation</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OPERATION_CALL_DESCRIPTOR__POINTER_REPRESENTATION = VALUE_DESCRIPTOR__POINTER_REPRESENTATION;

	/**
	 * The number of structural features of the '<em>Operation Call Descriptor</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OPERATION_CALL_DESCRIPTOR_FEATURE_COUNT = VALUE_DESCRIPTOR_FEATURE_COUNT + 0;

	/**
	 * The number of operations of the '<em>Operation Call Descriptor</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OPERATION_CALL_DESCRIPTOR_OPERATION_COUNT = VALUE_DESCRIPTOR_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.incquerylabs.emdw.valuedescriptor.impl.SingleVariableDescriptorImpl <em>Single Variable Descriptor</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.incquerylabs.emdw.valuedescriptor.impl.SingleVariableDescriptorImpl
	 * @see com.incquerylabs.emdw.valuedescriptor.impl.ValuedescriptorPackageImpl#getSingleVariableDescriptor()
	 * @generated
	 */
	int SINGLE_VARIABLE_DESCRIPTOR = 4;

	/**
	 * The feature id for the '<em><b>Base Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SINGLE_VARIABLE_DESCRIPTOR__BASE_TYPE = VARIABLE_DESCRIPTOR__BASE_TYPE;

	/**
	 * The feature id for the '<em><b>Template Types</b></em>' attribute list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SINGLE_VARIABLE_DESCRIPTOR__TEMPLATE_TYPES = VARIABLE_DESCRIPTOR__TEMPLATE_TYPES;

	/**
	 * The feature id for the '<em><b>Full Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SINGLE_VARIABLE_DESCRIPTOR__FULL_TYPE = VARIABLE_DESCRIPTOR__FULL_TYPE;

	/**
	 * The feature id for the '<em><b>String Representation</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SINGLE_VARIABLE_DESCRIPTOR__STRING_REPRESENTATION = VARIABLE_DESCRIPTOR__STRING_REPRESENTATION;

	/**
	 * The feature id for the '<em><b>Value Representation</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SINGLE_VARIABLE_DESCRIPTOR__VALUE_REPRESENTATION = VARIABLE_DESCRIPTOR__VALUE_REPRESENTATION;

	/**
	 * The feature id for the '<em><b>Pointer Representation</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SINGLE_VARIABLE_DESCRIPTOR__POINTER_REPRESENTATION = VARIABLE_DESCRIPTOR__POINTER_REPRESENTATION;

	/**
	 * The number of structural features of the '<em>Single Variable Descriptor</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SINGLE_VARIABLE_DESCRIPTOR_FEATURE_COUNT = VARIABLE_DESCRIPTOR_FEATURE_COUNT + 0;

	/**
	 * The number of operations of the '<em>Single Variable Descriptor</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SINGLE_VARIABLE_DESCRIPTOR_OPERATION_COUNT = VARIABLE_DESCRIPTOR_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.incquerylabs.emdw.valuedescriptor.impl.CollectionVariableDescriptorImpl <em>Collection Variable Descriptor</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.incquerylabs.emdw.valuedescriptor.impl.CollectionVariableDescriptorImpl
	 * @see com.incquerylabs.emdw.valuedescriptor.impl.ValuedescriptorPackageImpl#getCollectionVariableDescriptor()
	 * @generated
	 */
	int COLLECTION_VARIABLE_DESCRIPTOR = 5;

	/**
	 * The feature id for the '<em><b>Base Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COLLECTION_VARIABLE_DESCRIPTOR__BASE_TYPE = VARIABLE_DESCRIPTOR__BASE_TYPE;

	/**
	 * The feature id for the '<em><b>Template Types</b></em>' attribute list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COLLECTION_VARIABLE_DESCRIPTOR__TEMPLATE_TYPES = VARIABLE_DESCRIPTOR__TEMPLATE_TYPES;

	/**
	 * The feature id for the '<em><b>Full Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COLLECTION_VARIABLE_DESCRIPTOR__FULL_TYPE = VARIABLE_DESCRIPTOR__FULL_TYPE;

	/**
	 * The feature id for the '<em><b>String Representation</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COLLECTION_VARIABLE_DESCRIPTOR__STRING_REPRESENTATION = VARIABLE_DESCRIPTOR__STRING_REPRESENTATION;

	/**
	 * The feature id for the '<em><b>Value Representation</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COLLECTION_VARIABLE_DESCRIPTOR__VALUE_REPRESENTATION = VARIABLE_DESCRIPTOR__VALUE_REPRESENTATION;

	/**
	 * The feature id for the '<em><b>Pointer Representation</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COLLECTION_VARIABLE_DESCRIPTOR__POINTER_REPRESENTATION = VARIABLE_DESCRIPTOR__POINTER_REPRESENTATION;

	/**
	 * The feature id for the '<em><b>Collection Namespace</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COLLECTION_VARIABLE_DESCRIPTOR__COLLECTION_NAMESPACE = VARIABLE_DESCRIPTOR_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Collection Variable Descriptor</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COLLECTION_VARIABLE_DESCRIPTOR_FEATURE_COUNT = VARIABLE_DESCRIPTOR_FEATURE_COUNT + 1;

	/**
	 * The number of operations of the '<em>Collection Variable Descriptor</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COLLECTION_VARIABLE_DESCRIPTOR_OPERATION_COUNT = VARIABLE_DESCRIPTOR_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.incquerylabs.emdw.valuedescriptor.impl.PropertyAccessDescriptorImpl <em>Property Access Descriptor</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.incquerylabs.emdw.valuedescriptor.impl.PropertyAccessDescriptorImpl
	 * @see com.incquerylabs.emdw.valuedescriptor.impl.ValuedescriptorPackageImpl#getPropertyAccessDescriptor()
	 * @generated
	 */
	int PROPERTY_ACCESS_DESCRIPTOR = 6;

	/**
	 * The feature id for the '<em><b>Base Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_ACCESS_DESCRIPTOR__BASE_TYPE = VALUE_DESCRIPTOR__BASE_TYPE;

	/**
	 * The feature id for the '<em><b>Template Types</b></em>' attribute list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_ACCESS_DESCRIPTOR__TEMPLATE_TYPES = VALUE_DESCRIPTOR__TEMPLATE_TYPES;

	/**
	 * The feature id for the '<em><b>Full Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_ACCESS_DESCRIPTOR__FULL_TYPE = VALUE_DESCRIPTOR__FULL_TYPE;

	/**
	 * The feature id for the '<em><b>String Representation</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_ACCESS_DESCRIPTOR__STRING_REPRESENTATION = VALUE_DESCRIPTOR__STRING_REPRESENTATION;

	/**
	 * The feature id for the '<em><b>Value Representation</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_ACCESS_DESCRIPTOR__VALUE_REPRESENTATION = VALUE_DESCRIPTOR__VALUE_REPRESENTATION;

	/**
	 * The feature id for the '<em><b>Pointer Representation</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_ACCESS_DESCRIPTOR__POINTER_REPRESENTATION = VALUE_DESCRIPTOR__POINTER_REPRESENTATION;

	/**
	 * The number of structural features of the '<em>Property Access Descriptor</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_ACCESS_DESCRIPTOR_FEATURE_COUNT = VALUE_DESCRIPTOR_FEATURE_COUNT + 0;

	/**
	 * The number of operations of the '<em>Property Access Descriptor</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_ACCESS_DESCRIPTOR_OPERATION_COUNT = VALUE_DESCRIPTOR_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.incquerylabs.emdw.valuedescriptor.impl.PropertyReadDescriptorImpl <em>Property Read Descriptor</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.incquerylabs.emdw.valuedescriptor.impl.PropertyReadDescriptorImpl
	 * @see com.incquerylabs.emdw.valuedescriptor.impl.ValuedescriptorPackageImpl#getPropertyReadDescriptor()
	 * @generated
	 */
	int PROPERTY_READ_DESCRIPTOR = 7;

	/**
	 * The feature id for the '<em><b>Base Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_READ_DESCRIPTOR__BASE_TYPE = PROPERTY_ACCESS_DESCRIPTOR__BASE_TYPE;

	/**
	 * The feature id for the '<em><b>Template Types</b></em>' attribute list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_READ_DESCRIPTOR__TEMPLATE_TYPES = PROPERTY_ACCESS_DESCRIPTOR__TEMPLATE_TYPES;

	/**
	 * The feature id for the '<em><b>Full Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_READ_DESCRIPTOR__FULL_TYPE = PROPERTY_ACCESS_DESCRIPTOR__FULL_TYPE;

	/**
	 * The feature id for the '<em><b>String Representation</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_READ_DESCRIPTOR__STRING_REPRESENTATION = PROPERTY_ACCESS_DESCRIPTOR__STRING_REPRESENTATION;

	/**
	 * The feature id for the '<em><b>Value Representation</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_READ_DESCRIPTOR__VALUE_REPRESENTATION = PROPERTY_ACCESS_DESCRIPTOR__VALUE_REPRESENTATION;

	/**
	 * The feature id for the '<em><b>Pointer Representation</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_READ_DESCRIPTOR__POINTER_REPRESENTATION = PROPERTY_ACCESS_DESCRIPTOR__POINTER_REPRESENTATION;

	/**
	 * The number of structural features of the '<em>Property Read Descriptor</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_READ_DESCRIPTOR_FEATURE_COUNT = PROPERTY_ACCESS_DESCRIPTOR_FEATURE_COUNT + 0;

	/**
	 * The number of operations of the '<em>Property Read Descriptor</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_READ_DESCRIPTOR_OPERATION_COUNT = PROPERTY_ACCESS_DESCRIPTOR_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.incquerylabs.emdw.valuedescriptor.impl.PropertyWriteDescriptorImpl <em>Property Write Descriptor</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.incquerylabs.emdw.valuedescriptor.impl.PropertyWriteDescriptorImpl
	 * @see com.incquerylabs.emdw.valuedescriptor.impl.ValuedescriptorPackageImpl#getPropertyWriteDescriptor()
	 * @generated
	 */
	int PROPERTY_WRITE_DESCRIPTOR = 8;

	/**
	 * The feature id for the '<em><b>Base Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_WRITE_DESCRIPTOR__BASE_TYPE = PROPERTY_ACCESS_DESCRIPTOR__BASE_TYPE;

	/**
	 * The feature id for the '<em><b>Template Types</b></em>' attribute list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_WRITE_DESCRIPTOR__TEMPLATE_TYPES = PROPERTY_ACCESS_DESCRIPTOR__TEMPLATE_TYPES;

	/**
	 * The feature id for the '<em><b>Full Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_WRITE_DESCRIPTOR__FULL_TYPE = PROPERTY_ACCESS_DESCRIPTOR__FULL_TYPE;

	/**
	 * The feature id for the '<em><b>String Representation</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_WRITE_DESCRIPTOR__STRING_REPRESENTATION = PROPERTY_ACCESS_DESCRIPTOR__STRING_REPRESENTATION;

	/**
	 * The feature id for the '<em><b>Value Representation</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_WRITE_DESCRIPTOR__VALUE_REPRESENTATION = PROPERTY_ACCESS_DESCRIPTOR__VALUE_REPRESENTATION;

	/**
	 * The feature id for the '<em><b>Pointer Representation</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_WRITE_DESCRIPTOR__POINTER_REPRESENTATION = PROPERTY_ACCESS_DESCRIPTOR__POINTER_REPRESENTATION;

	/**
	 * The number of structural features of the '<em>Property Write Descriptor</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_WRITE_DESCRIPTOR_FEATURE_COUNT = PROPERTY_ACCESS_DESCRIPTOR_FEATURE_COUNT + 0;

	/**
	 * The number of operations of the '<em>Property Write Descriptor</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_WRITE_DESCRIPTOR_OPERATION_COUNT = PROPERTY_ACCESS_DESCRIPTOR_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.incquerylabs.emdw.valuedescriptor.impl.ParameterDescriptorImpl <em>Parameter Descriptor</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.incquerylabs.emdw.valuedescriptor.impl.ParameterDescriptorImpl
	 * @see com.incquerylabs.emdw.valuedescriptor.impl.ValuedescriptorPackageImpl#getParameterDescriptor()
	 * @generated
	 */
	int PARAMETER_DESCRIPTOR = 9;

	/**
	 * The feature id for the '<em><b>Base Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PARAMETER_DESCRIPTOR__BASE_TYPE = VARIABLE_DESCRIPTOR__BASE_TYPE;

	/**
	 * The feature id for the '<em><b>Template Types</b></em>' attribute list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PARAMETER_DESCRIPTOR__TEMPLATE_TYPES = VARIABLE_DESCRIPTOR__TEMPLATE_TYPES;

	/**
	 * The feature id for the '<em><b>Full Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PARAMETER_DESCRIPTOR__FULL_TYPE = VARIABLE_DESCRIPTOR__FULL_TYPE;

	/**
	 * The feature id for the '<em><b>String Representation</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PARAMETER_DESCRIPTOR__STRING_REPRESENTATION = VARIABLE_DESCRIPTOR__STRING_REPRESENTATION;

	/**
	 * The feature id for the '<em><b>Value Representation</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PARAMETER_DESCRIPTOR__VALUE_REPRESENTATION = VARIABLE_DESCRIPTOR__VALUE_REPRESENTATION;

	/**
	 * The feature id for the '<em><b>Pointer Representation</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PARAMETER_DESCRIPTOR__POINTER_REPRESENTATION = VARIABLE_DESCRIPTOR__POINTER_REPRESENTATION;

	/**
	 * The number of structural features of the '<em>Parameter Descriptor</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PARAMETER_DESCRIPTOR_FEATURE_COUNT = VARIABLE_DESCRIPTOR_FEATURE_COUNT + 0;

	/**
	 * The number of operations of the '<em>Parameter Descriptor</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PARAMETER_DESCRIPTOR_OPERATION_COUNT = VARIABLE_DESCRIPTOR_OPERATION_COUNT + 0;


	/**
	 * Returns the meta object for class '{@link com.incquerylabs.emdw.valuedescriptor.ValueDescriptor <em>Value Descriptor</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Value Descriptor</em>'.
	 * @see com.incquerylabs.emdw.valuedescriptor.ValueDescriptor
	 * @generated
	 */
	EClass getValueDescriptor();

	/**
	 * Returns the meta object for the attribute '{@link com.incquerylabs.emdw.valuedescriptor.ValueDescriptor#getBaseType <em>Base Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Base Type</em>'.
	 * @see com.incquerylabs.emdw.valuedescriptor.ValueDescriptor#getBaseType()
	 * @see #getValueDescriptor()
	 * @generated
	 */
	EAttribute getValueDescriptor_BaseType();

	/**
	 * Returns the meta object for the attribute list '{@link com.incquerylabs.emdw.valuedescriptor.ValueDescriptor#getTemplateTypes <em>Template Types</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute list '<em>Template Types</em>'.
	 * @see com.incquerylabs.emdw.valuedescriptor.ValueDescriptor#getTemplateTypes()
	 * @see #getValueDescriptor()
	 * @generated
	 */
	EAttribute getValueDescriptor_TemplateTypes();

	/**
	 * Returns the meta object for the attribute '{@link com.incquerylabs.emdw.valuedescriptor.ValueDescriptor#getFullType <em>Full Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Full Type</em>'.
	 * @see com.incquerylabs.emdw.valuedescriptor.ValueDescriptor#getFullType()
	 * @see #getValueDescriptor()
	 * @generated
	 */
	EAttribute getValueDescriptor_FullType();

	/**
	 * Returns the meta object for the attribute '{@link com.incquerylabs.emdw.valuedescriptor.ValueDescriptor#getStringRepresentation <em>String Representation</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>String Representation</em>'.
	 * @see com.incquerylabs.emdw.valuedescriptor.ValueDescriptor#getStringRepresentation()
	 * @see #getValueDescriptor()
	 * @generated
	 */
	EAttribute getValueDescriptor_StringRepresentation();

	/**
	 * Returns the meta object for the attribute '{@link com.incquerylabs.emdw.valuedescriptor.ValueDescriptor#getValueRepresentation <em>Value Representation</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Value Representation</em>'.
	 * @see com.incquerylabs.emdw.valuedescriptor.ValueDescriptor#getValueRepresentation()
	 * @see #getValueDescriptor()
	 * @generated
	 */
	EAttribute getValueDescriptor_ValueRepresentation();

	/**
	 * Returns the meta object for the attribute '{@link com.incquerylabs.emdw.valuedescriptor.ValueDescriptor#getPointerRepresentation <em>Pointer Representation</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Pointer Representation</em>'.
	 * @see com.incquerylabs.emdw.valuedescriptor.ValueDescriptor#getPointerRepresentation()
	 * @see #getValueDescriptor()
	 * @generated
	 */
	EAttribute getValueDescriptor_PointerRepresentation();

	/**
	 * Returns the meta object for class '{@link com.incquerylabs.emdw.valuedescriptor.LiteralDescriptor <em>Literal Descriptor</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Literal Descriptor</em>'.
	 * @see com.incquerylabs.emdw.valuedescriptor.LiteralDescriptor
	 * @generated
	 */
	EClass getLiteralDescriptor();

	/**
	 * Returns the meta object for class '{@link com.incquerylabs.emdw.valuedescriptor.VariableDescriptor <em>Variable Descriptor</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Variable Descriptor</em>'.
	 * @see com.incquerylabs.emdw.valuedescriptor.VariableDescriptor
	 * @generated
	 */
	EClass getVariableDescriptor();

	/**
	 * Returns the meta object for class '{@link com.incquerylabs.emdw.valuedescriptor.OperationCallDescriptor <em>Operation Call Descriptor</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Operation Call Descriptor</em>'.
	 * @see com.incquerylabs.emdw.valuedescriptor.OperationCallDescriptor
	 * @generated
	 */
	EClass getOperationCallDescriptor();

	/**
	 * Returns the meta object for class '{@link com.incquerylabs.emdw.valuedescriptor.SingleVariableDescriptor <em>Single Variable Descriptor</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Single Variable Descriptor</em>'.
	 * @see com.incquerylabs.emdw.valuedescriptor.SingleVariableDescriptor
	 * @generated
	 */
	EClass getSingleVariableDescriptor();

	/**
	 * Returns the meta object for class '{@link com.incquerylabs.emdw.valuedescriptor.CollectionVariableDescriptor <em>Collection Variable Descriptor</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Collection Variable Descriptor</em>'.
	 * @see com.incquerylabs.emdw.valuedescriptor.CollectionVariableDescriptor
	 * @generated
	 */
	EClass getCollectionVariableDescriptor();

	/**
	 * Returns the meta object for the attribute '{@link com.incquerylabs.emdw.valuedescriptor.CollectionVariableDescriptor#getCollectionNamespace <em>Collection Namespace</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Collection Namespace</em>'.
	 * @see com.incquerylabs.emdw.valuedescriptor.CollectionVariableDescriptor#getCollectionNamespace()
	 * @see #getCollectionVariableDescriptor()
	 * @generated
	 */
	EAttribute getCollectionVariableDescriptor_CollectionNamespace();

	/**
	 * Returns the meta object for class '{@link com.incquerylabs.emdw.valuedescriptor.PropertyAccessDescriptor <em>Property Access Descriptor</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Property Access Descriptor</em>'.
	 * @see com.incquerylabs.emdw.valuedescriptor.PropertyAccessDescriptor
	 * @generated
	 */
	EClass getPropertyAccessDescriptor();

	/**
	 * Returns the meta object for class '{@link com.incquerylabs.emdw.valuedescriptor.PropertyReadDescriptor <em>Property Read Descriptor</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Property Read Descriptor</em>'.
	 * @see com.incquerylabs.emdw.valuedescriptor.PropertyReadDescriptor
	 * @generated
	 */
	EClass getPropertyReadDescriptor();

	/**
	 * Returns the meta object for class '{@link com.incquerylabs.emdw.valuedescriptor.PropertyWriteDescriptor <em>Property Write Descriptor</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Property Write Descriptor</em>'.
	 * @see com.incquerylabs.emdw.valuedescriptor.PropertyWriteDescriptor
	 * @generated
	 */
	EClass getPropertyWriteDescriptor();

	/**
	 * Returns the meta object for class '{@link com.incquerylabs.emdw.valuedescriptor.ParameterDescriptor <em>Parameter Descriptor</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Parameter Descriptor</em>'.
	 * @see com.incquerylabs.emdw.valuedescriptor.ParameterDescriptor
	 * @generated
	 */
	EClass getParameterDescriptor();

	/**
	 * Returns the factory that creates the instances of the model.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the factory that creates the instances of the model.
	 * @generated
	 */
	ValuedescriptorFactory getValuedescriptorFactory();

	/**
	 * <!-- begin-user-doc -->
	 * Defines literals for the meta objects that represent
	 * <ul>
	 *   <li>each class,</li>
	 *   <li>each feature of each class,</li>
	 *   <li>each operation of each class,</li>
	 *   <li>each enum,</li>
	 *   <li>and each data type</li>
	 * </ul>
	 * <!-- end-user-doc -->
	 * @generated
	 */
	interface Literals {
		/**
		 * The meta object literal for the '{@link com.incquerylabs.emdw.valuedescriptor.impl.ValueDescriptorImpl <em>Value Descriptor</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.incquerylabs.emdw.valuedescriptor.impl.ValueDescriptorImpl
		 * @see com.incquerylabs.emdw.valuedescriptor.impl.ValuedescriptorPackageImpl#getValueDescriptor()
		 * @generated
		 */
		EClass VALUE_DESCRIPTOR = eINSTANCE.getValueDescriptor();

		/**
		 * The meta object literal for the '<em><b>Base Type</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute VALUE_DESCRIPTOR__BASE_TYPE = eINSTANCE.getValueDescriptor_BaseType();

		/**
		 * The meta object literal for the '<em><b>Template Types</b></em>' attribute list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute VALUE_DESCRIPTOR__TEMPLATE_TYPES = eINSTANCE.getValueDescriptor_TemplateTypes();

		/**
		 * The meta object literal for the '<em><b>Full Type</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute VALUE_DESCRIPTOR__FULL_TYPE = eINSTANCE.getValueDescriptor_FullType();

		/**
		 * The meta object literal for the '<em><b>String Representation</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute VALUE_DESCRIPTOR__STRING_REPRESENTATION = eINSTANCE.getValueDescriptor_StringRepresentation();

		/**
		 * The meta object literal for the '<em><b>Value Representation</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute VALUE_DESCRIPTOR__VALUE_REPRESENTATION = eINSTANCE.getValueDescriptor_ValueRepresentation();

		/**
		 * The meta object literal for the '<em><b>Pointer Representation</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute VALUE_DESCRIPTOR__POINTER_REPRESENTATION = eINSTANCE.getValueDescriptor_PointerRepresentation();

		/**
		 * The meta object literal for the '{@link com.incquerylabs.emdw.valuedescriptor.impl.LiteralDescriptorImpl <em>Literal Descriptor</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.incquerylabs.emdw.valuedescriptor.impl.LiteralDescriptorImpl
		 * @see com.incquerylabs.emdw.valuedescriptor.impl.ValuedescriptorPackageImpl#getLiteralDescriptor()
		 * @generated
		 */
		EClass LITERAL_DESCRIPTOR = eINSTANCE.getLiteralDescriptor();

		/**
		 * The meta object literal for the '{@link com.incquerylabs.emdw.valuedescriptor.impl.VariableDescriptorImpl <em>Variable Descriptor</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.incquerylabs.emdw.valuedescriptor.impl.VariableDescriptorImpl
		 * @see com.incquerylabs.emdw.valuedescriptor.impl.ValuedescriptorPackageImpl#getVariableDescriptor()
		 * @generated
		 */
		EClass VARIABLE_DESCRIPTOR = eINSTANCE.getVariableDescriptor();

		/**
		 * The meta object literal for the '{@link com.incquerylabs.emdw.valuedescriptor.impl.OperationCallDescriptorImpl <em>Operation Call Descriptor</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.incquerylabs.emdw.valuedescriptor.impl.OperationCallDescriptorImpl
		 * @see com.incquerylabs.emdw.valuedescriptor.impl.ValuedescriptorPackageImpl#getOperationCallDescriptor()
		 * @generated
		 */
		EClass OPERATION_CALL_DESCRIPTOR = eINSTANCE.getOperationCallDescriptor();

		/**
		 * The meta object literal for the '{@link com.incquerylabs.emdw.valuedescriptor.impl.SingleVariableDescriptorImpl <em>Single Variable Descriptor</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.incquerylabs.emdw.valuedescriptor.impl.SingleVariableDescriptorImpl
		 * @see com.incquerylabs.emdw.valuedescriptor.impl.ValuedescriptorPackageImpl#getSingleVariableDescriptor()
		 * @generated
		 */
		EClass SINGLE_VARIABLE_DESCRIPTOR = eINSTANCE.getSingleVariableDescriptor();

		/**
		 * The meta object literal for the '{@link com.incquerylabs.emdw.valuedescriptor.impl.CollectionVariableDescriptorImpl <em>Collection Variable Descriptor</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.incquerylabs.emdw.valuedescriptor.impl.CollectionVariableDescriptorImpl
		 * @see com.incquerylabs.emdw.valuedescriptor.impl.ValuedescriptorPackageImpl#getCollectionVariableDescriptor()
		 * @generated
		 */
		EClass COLLECTION_VARIABLE_DESCRIPTOR = eINSTANCE.getCollectionVariableDescriptor();

		/**
		 * The meta object literal for the '<em><b>Collection Namespace</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute COLLECTION_VARIABLE_DESCRIPTOR__COLLECTION_NAMESPACE = eINSTANCE.getCollectionVariableDescriptor_CollectionNamespace();

		/**
		 * The meta object literal for the '{@link com.incquerylabs.emdw.valuedescriptor.impl.PropertyAccessDescriptorImpl <em>Property Access Descriptor</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.incquerylabs.emdw.valuedescriptor.impl.PropertyAccessDescriptorImpl
		 * @see com.incquerylabs.emdw.valuedescriptor.impl.ValuedescriptorPackageImpl#getPropertyAccessDescriptor()
		 * @generated
		 */
		EClass PROPERTY_ACCESS_DESCRIPTOR = eINSTANCE.getPropertyAccessDescriptor();

		/**
		 * The meta object literal for the '{@link com.incquerylabs.emdw.valuedescriptor.impl.PropertyReadDescriptorImpl <em>Property Read Descriptor</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.incquerylabs.emdw.valuedescriptor.impl.PropertyReadDescriptorImpl
		 * @see com.incquerylabs.emdw.valuedescriptor.impl.ValuedescriptorPackageImpl#getPropertyReadDescriptor()
		 * @generated
		 */
		EClass PROPERTY_READ_DESCRIPTOR = eINSTANCE.getPropertyReadDescriptor();

		/**
		 * The meta object literal for the '{@link com.incquerylabs.emdw.valuedescriptor.impl.PropertyWriteDescriptorImpl <em>Property Write Descriptor</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.incquerylabs.emdw.valuedescriptor.impl.PropertyWriteDescriptorImpl
		 * @see com.incquerylabs.emdw.valuedescriptor.impl.ValuedescriptorPackageImpl#getPropertyWriteDescriptor()
		 * @generated
		 */
		EClass PROPERTY_WRITE_DESCRIPTOR = eINSTANCE.getPropertyWriteDescriptor();

		/**
		 * The meta object literal for the '{@link com.incquerylabs.emdw.valuedescriptor.impl.ParameterDescriptorImpl <em>Parameter Descriptor</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see com.incquerylabs.emdw.valuedescriptor.impl.ParameterDescriptorImpl
		 * @see com.incquerylabs.emdw.valuedescriptor.impl.ValuedescriptorPackageImpl#getParameterDescriptor()
		 * @generated
		 */
		EClass PARAMETER_DESCRIPTOR = eINSTANCE.getParameterDescriptor();

	}

} //ValuedescriptorPackage
