/**
 * Copyright (c) 2015-2016 IncQuery Labs Ltd. and Ericsson AB
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *     Akos Horvath, Abel Hegedus, Zoltan Ujhelyi, Tamas Borbas - initial API and implementation
 */
package com.incquerylabs.emdw.valuedescriptor.impl;

import com.incquerylabs.emdw.valuedescriptor.ValueDescriptor;
import com.incquerylabs.emdw.valuedescriptor.ValuedescriptorPackage;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;

import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.MinimalEObjectImpl;

import org.eclipse.emf.ecore.util.EDataTypeUniqueEList;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Value Descriptor</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link com.incquerylabs.emdw.valuedescriptor.impl.ValueDescriptorImpl#getBaseType <em>Base Type</em>}</li>
 *   <li>{@link com.incquerylabs.emdw.valuedescriptor.impl.ValueDescriptorImpl#getTemplateTypes <em>Template Types</em>}</li>
 *   <li>{@link com.incquerylabs.emdw.valuedescriptor.impl.ValueDescriptorImpl#getFullType <em>Full Type</em>}</li>
 *   <li>{@link com.incquerylabs.emdw.valuedescriptor.impl.ValueDescriptorImpl#getStringRepresentation <em>String Representation</em>}</li>
 *   <li>{@link com.incquerylabs.emdw.valuedescriptor.impl.ValueDescriptorImpl#getValueRepresentation <em>Value Representation</em>}</li>
 *   <li>{@link com.incquerylabs.emdw.valuedescriptor.impl.ValueDescriptorImpl#getPointerRepresentation <em>Pointer Representation</em>}</li>
 * </ul>
 *
 * @generated
 */
public abstract class ValueDescriptorImpl extends MinimalEObjectImpl.Container implements ValueDescriptor {
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static final String copyright = "Copyright (c) 2015-2016 IncQuery Labs Ltd. and Ericsson AB\r\nAll rights reserved. This program and the accompanying materials\r\nare made available under the terms of the Eclipse Public License v1.0\r\nwhich accompanies this distribution, and is available at\r\nhttp://www.eclipse.org/legal/epl-v10.html\r\n\r\nContributors:\r\n    Akos Horvath, Abel Hegedus, Zoltan Ujhelyi, Tamas Borbas - initial API and implementation";

	/**
	 * The default value of the '{@link #getBaseType() <em>Base Type</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getBaseType()
	 * @generated
	 * @ordered
	 */
	protected static final String BASE_TYPE_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getBaseType() <em>Base Type</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getBaseType()
	 * @generated
	 * @ordered
	 */
	protected String baseType = BASE_TYPE_EDEFAULT;

	/**
	 * The cached value of the '{@link #getTemplateTypes() <em>Template Types</em>}' attribute list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getTemplateTypes()
	 * @generated
	 * @ordered
	 */
	protected EList<String> templateTypes;

	/**
	 * The default value of the '{@link #getFullType() <em>Full Type</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getFullType()
	 * @generated
	 * @ordered
	 */
	protected static final String FULL_TYPE_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getFullType() <em>Full Type</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getFullType()
	 * @generated
	 * @ordered
	 */
	protected String fullType = FULL_TYPE_EDEFAULT;

	/**
	 * The default value of the '{@link #getStringRepresentation() <em>String Representation</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getStringRepresentation()
	 * @generated
	 * @ordered
	 */
	protected static final String STRING_REPRESENTATION_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getStringRepresentation() <em>String Representation</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getStringRepresentation()
	 * @generated
	 * @ordered
	 */
	protected String stringRepresentation = STRING_REPRESENTATION_EDEFAULT;

	/**
	 * The default value of the '{@link #getValueRepresentation() <em>Value Representation</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getValueRepresentation()
	 * @generated
	 * @ordered
	 */
	protected static final String VALUE_REPRESENTATION_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getValueRepresentation() <em>Value Representation</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getValueRepresentation()
	 * @generated
	 * @ordered
	 */
	protected String valueRepresentation = VALUE_REPRESENTATION_EDEFAULT;

	/**
	 * The default value of the '{@link #getPointerRepresentation() <em>Pointer Representation</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getPointerRepresentation()
	 * @generated
	 * @ordered
	 */
	protected static final String POINTER_REPRESENTATION_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getPointerRepresentation() <em>Pointer Representation</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getPointerRepresentation()
	 * @generated
	 * @ordered
	 */
	protected String pointerRepresentation = POINTER_REPRESENTATION_EDEFAULT;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ValueDescriptorImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return ValuedescriptorPackage.Literals.VALUE_DESCRIPTOR;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getBaseType() {
		return baseType;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setBaseType(String newBaseType) {
		String oldBaseType = baseType;
		baseType = newBaseType;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ValuedescriptorPackage.VALUE_DESCRIPTOR__BASE_TYPE, oldBaseType, baseType));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<String> getTemplateTypes() {
		if (templateTypes == null) {
			templateTypes = new EDataTypeUniqueEList<String>(String.class, this, ValuedescriptorPackage.VALUE_DESCRIPTOR__TEMPLATE_TYPES);
		}
		return templateTypes;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getFullType() {
		return fullType;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setFullType(String newFullType) {
		String oldFullType = fullType;
		fullType = newFullType;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ValuedescriptorPackage.VALUE_DESCRIPTOR__FULL_TYPE, oldFullType, fullType));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getStringRepresentation() {
		return stringRepresentation;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setStringRepresentation(String newStringRepresentation) {
		String oldStringRepresentation = stringRepresentation;
		stringRepresentation = newStringRepresentation;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ValuedescriptorPackage.VALUE_DESCRIPTOR__STRING_REPRESENTATION, oldStringRepresentation, stringRepresentation));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getValueRepresentation() {
		return valueRepresentation;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setValueRepresentation(String newValueRepresentation) {
		String oldValueRepresentation = valueRepresentation;
		valueRepresentation = newValueRepresentation;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ValuedescriptorPackage.VALUE_DESCRIPTOR__VALUE_REPRESENTATION, oldValueRepresentation, valueRepresentation));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getPointerRepresentation() {
		return pointerRepresentation;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setPointerRepresentation(String newPointerRepresentation) {
		String oldPointerRepresentation = pointerRepresentation;
		pointerRepresentation = newPointerRepresentation;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ValuedescriptorPackage.VALUE_DESCRIPTOR__POINTER_REPRESENTATION, oldPointerRepresentation, pointerRepresentation));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case ValuedescriptorPackage.VALUE_DESCRIPTOR__BASE_TYPE:
				return getBaseType();
			case ValuedescriptorPackage.VALUE_DESCRIPTOR__TEMPLATE_TYPES:
				return getTemplateTypes();
			case ValuedescriptorPackage.VALUE_DESCRIPTOR__FULL_TYPE:
				return getFullType();
			case ValuedescriptorPackage.VALUE_DESCRIPTOR__STRING_REPRESENTATION:
				return getStringRepresentation();
			case ValuedescriptorPackage.VALUE_DESCRIPTOR__VALUE_REPRESENTATION:
				return getValueRepresentation();
			case ValuedescriptorPackage.VALUE_DESCRIPTOR__POINTER_REPRESENTATION:
				return getPointerRepresentation();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case ValuedescriptorPackage.VALUE_DESCRIPTOR__BASE_TYPE:
				setBaseType((String)newValue);
				return;
			case ValuedescriptorPackage.VALUE_DESCRIPTOR__TEMPLATE_TYPES:
				getTemplateTypes().clear();
				getTemplateTypes().addAll((Collection<? extends String>)newValue);
				return;
			case ValuedescriptorPackage.VALUE_DESCRIPTOR__FULL_TYPE:
				setFullType((String)newValue);
				return;
			case ValuedescriptorPackage.VALUE_DESCRIPTOR__STRING_REPRESENTATION:
				setStringRepresentation((String)newValue);
				return;
			case ValuedescriptorPackage.VALUE_DESCRIPTOR__VALUE_REPRESENTATION:
				setValueRepresentation((String)newValue);
				return;
			case ValuedescriptorPackage.VALUE_DESCRIPTOR__POINTER_REPRESENTATION:
				setPointerRepresentation((String)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case ValuedescriptorPackage.VALUE_DESCRIPTOR__BASE_TYPE:
				setBaseType(BASE_TYPE_EDEFAULT);
				return;
			case ValuedescriptorPackage.VALUE_DESCRIPTOR__TEMPLATE_TYPES:
				getTemplateTypes().clear();
				return;
			case ValuedescriptorPackage.VALUE_DESCRIPTOR__FULL_TYPE:
				setFullType(FULL_TYPE_EDEFAULT);
				return;
			case ValuedescriptorPackage.VALUE_DESCRIPTOR__STRING_REPRESENTATION:
				setStringRepresentation(STRING_REPRESENTATION_EDEFAULT);
				return;
			case ValuedescriptorPackage.VALUE_DESCRIPTOR__VALUE_REPRESENTATION:
				setValueRepresentation(VALUE_REPRESENTATION_EDEFAULT);
				return;
			case ValuedescriptorPackage.VALUE_DESCRIPTOR__POINTER_REPRESENTATION:
				setPointerRepresentation(POINTER_REPRESENTATION_EDEFAULT);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case ValuedescriptorPackage.VALUE_DESCRIPTOR__BASE_TYPE:
				return BASE_TYPE_EDEFAULT == null ? baseType != null : !BASE_TYPE_EDEFAULT.equals(baseType);
			case ValuedescriptorPackage.VALUE_DESCRIPTOR__TEMPLATE_TYPES:
				return templateTypes != null && !templateTypes.isEmpty();
			case ValuedescriptorPackage.VALUE_DESCRIPTOR__FULL_TYPE:
				return FULL_TYPE_EDEFAULT == null ? fullType != null : !FULL_TYPE_EDEFAULT.equals(fullType);
			case ValuedescriptorPackage.VALUE_DESCRIPTOR__STRING_REPRESENTATION:
				return STRING_REPRESENTATION_EDEFAULT == null ? stringRepresentation != null : !STRING_REPRESENTATION_EDEFAULT.equals(stringRepresentation);
			case ValuedescriptorPackage.VALUE_DESCRIPTOR__VALUE_REPRESENTATION:
				return VALUE_REPRESENTATION_EDEFAULT == null ? valueRepresentation != null : !VALUE_REPRESENTATION_EDEFAULT.equals(valueRepresentation);
			case ValuedescriptorPackage.VALUE_DESCRIPTOR__POINTER_REPRESENTATION:
				return POINTER_REPRESENTATION_EDEFAULT == null ? pointerRepresentation != null : !POINTER_REPRESENTATION_EDEFAULT.equals(pointerRepresentation);
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (baseType: ");
		result.append(baseType);
		result.append(", templateTypes: ");
		result.append(templateTypes);
		result.append(", fullType: ");
		result.append(fullType);
		result.append(", stringRepresentation: ");
		result.append(stringRepresentation);
		result.append(", valueRepresentation: ");
		result.append(valueRepresentation);
		result.append(", pointerRepresentation: ");
		result.append(pointerRepresentation);
		result.append(')');
		return result.toString();
	}

} //ValueDescriptorImpl
